#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivityFishingCeleGiftLottery.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivityFishingCeleGiftLottery> M_ActivityFishingCeleGiftLottery::msSingleton(nullptr);

int M_ActivityFishingCeleGiftLottery::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleGiftLotteryData* M_ActivityFishingCeleGiftLottery::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivityFishingCeleGiftLotteryData>& M_ActivityFishingCeleGiftLottery::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleGiftLottery::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivityFishingCeleGiftLottery::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleGiftLotteryData data;
		data.mID = element->IntAttribute("ID");
		data.mLotteryCount = element->IntAttribute("LotteryCount");
		{
			const char* rewardItem = element->Attribute("rewardItem");
			std::vector<std::string> vecrewardItem;
			boost::split(vecrewardItem, rewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecrewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecrewardItem[i].c_str(), &temp))
				{
					data.mrewardItem.push_back(temp);
				}
			}
		}
		{
			const char* rewardCount = element->Attribute("rewardCount");
			std::vector<std::string> vecrewardCount;
			boost::split(vecrewardCount, rewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecrewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecrewardCount[i].c_str(), &temp))
				{
					data.mrewardCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivityFishingCeleGiftLottery::Load()
{
	Load("../Config/M_ActivityFishingCeleGiftLottery.xml");
}

M_ActivityFishingCeleGiftLottery* M_ActivityFishingCeleGiftLottery::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleGiftLottery());
	}
	return msSingleton.get();
}
